﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace Teachers.Models;

public partial class _43pGaruaevContext : DbContext
{
    public _43pGaruaevContext()
    {
    }

    public _43pGaruaevContext(DbContextOptions<_43pGaruaevContext> options)
        : base(options)
    {
    }

    public virtual DbSet<Course> Courses { get; set; }

    public virtual DbSet<Discipline> Disciplines { get; set; }

    public virtual DbSet<Gender> Genders { get; set; }

    public virtual DbSet<Teacher> Teachers { get; set; }

    public virtual DbSet<Teachercourse> Teachercourses { get; set; }

    public virtual DbSet<Teacherdiscipline> Teacherdisciplines { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see https://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.ru;Port=5442;Database=43P_Garuaev;Username=43P;Password=444444");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<Course>(entity =>
        {
            entity.HasKey(e => e.IdCourse).HasName("course_pkey");

            entity.ToTable("course");

            entity.Property(e => e.IdCourse).HasColumnName("id_course");
            entity.Property(e => e.Hours).HasColumnName("hours");
            entity.Property(e => e.Title)
                .HasMaxLength(100)
                .HasColumnName("title");
        });

        modelBuilder.Entity<Discipline>(entity =>
        {
            entity.HasKey(e => e.IdDiscipline).HasName("discipline_pkey");

            entity.ToTable("discipline");

            entity.Property(e => e.IdDiscipline).HasColumnName("id_discipline");
            entity.Property(e => e.Title)
                .HasMaxLength(50)
                .HasColumnName("title");
        });

        modelBuilder.Entity<Gender>(entity =>
        {
            entity.HasKey(e => e.IdGender).HasName("genders_pkey");

            entity.ToTable("genders");

            entity.Property(e => e.IdGender).HasColumnName("id_gender");
            entity.Property(e => e.Title)
                .HasMaxLength(10)
                .HasColumnName("title");
        });

        modelBuilder.Entity<Teacher>(entity =>
        {
            entity.HasKey(e => e.IdTeacher).HasName("teacher_pkey");

            entity.ToTable("teacher");

            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");
            entity.Property(e => e.Dateofbirth)
                .HasColumnType("timestamp without time zone")
                .HasColumnName("dateofbirth");
            entity.Property(e => e.Email)
                .HasMaxLength(30)
                .HasColumnName("email");
            entity.Property(e => e.Experience).HasColumnName("experience");
            entity.Property(e => e.Firstname)
                .HasMaxLength(30)
                .HasColumnName("firstname");
            entity.Property(e => e.Genderid).HasColumnName("genderid");
            entity.Property(e => e.Lastname)
                .HasMaxLength(30)
                .HasColumnName("lastname");
            entity.Property(e => e.Patronomic)
                .HasMaxLength(30)
                .HasColumnName("patronomic");
            entity.Property(e => e.Phone)
                .HasMaxLength(20)
                .HasColumnName("phone");

            entity.HasOne(d => d.Gender).WithMany(p => p.Teachers)
                .HasForeignKey(d => d.Genderid)
                .HasConstraintName("teacher_genderid_fkey");
        });

        modelBuilder.Entity<Teachercourse>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("teachercourse_pkey");

            entity.ToTable("teachercourse");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Courseid).HasColumnName("courseid");
            entity.Property(e => e.Teacherid).HasColumnName("teacherid");

            entity.HasOne(d => d.Course).WithMany(p => p.Teachercourses)
                .HasForeignKey(d => d.Courseid)
                .HasConstraintName("teachercourse_courseid_fkey");

            entity.HasOne(d => d.Teacher).WithMany(p => p.Teachercourses)
                .HasForeignKey(d => d.Teacherid)
                .HasConstraintName("teachercourse_teacherid_fkey");
        });

        modelBuilder.Entity<Teacherdiscipline>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("teacherdiscipline_pkey");

            entity.ToTable("teacherdiscipline");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Disciplineid).HasColumnName("disciplineid");
            entity.Property(e => e.Teacherid).HasColumnName("teacherid");

            entity.HasOne(d => d.Discipline).WithMany(p => p.Teacherdisciplines)
                .HasForeignKey(d => d.Disciplineid)
                .HasConstraintName("teacherdiscipline_disciplineid_fkey");

            entity.HasOne(d => d.Teacher).WithMany(p => p.Teacherdisciplines)
                .HasForeignKey(d => d.Teacherid)
                .HasConstraintName("teacherdiscipline_teacherid_fkey");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
