﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Avalonia.Controls;
using Microsoft.EntityFrameworkCore;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;
using ReactiveUI;
using Teachers.Models;

namespace Teachers.ViewModels
{
    internal class OneTeacherVM : ViewModelBase
    {

        string _nameBut;
        public string NameBut { get => _nameBut; set => this.RaiseAndSetIfChanged(ref _nameBut,value); }

        Teacher? _newTeacher;

        public Teacher? NewTeacher { get => _newTeacher; set => this.RaiseAndSetIfChanged(ref _newTeacher, value); }

        public OneTeacherVM()
        {
            _newTeacher = new Teacher() {Gender = new Gender()};
            _nameBut = "Добавить преподователя";
        }
        public List<Gender> Genders => MainWindowViewModel.myConnection.Genders.ToList();
        public List<Discipline> Disciplines => MainWindowViewModel.myConnection.Disciplines.ToList().Except(_newTeacher.Teacherdisciplines.Select(x => x.Discipline)).ToList();
        public List<Course> Courses => MainWindowViewModel.myConnection.Courses.ToList().Except(_newTeacher.Teachercourses.Select(x => x.Course)).ToList();

        public OneTeacherVM(int idTeacher)
        {
            _newTeacher = MainWindowViewModel.myConnection.Teachers.Include(x => x.Teacherdisciplines).ThenInclude(x => x.Discipline)
                                                                   .Include(x => x.Teachercourses).ThenInclude(x => x.Course).FirstOrDefault(x => x.IdTeacher == idTeacher);
            Teacherdisciplines = NewTeacher.Teacherdisciplines.ToList();
            Teachercourses = NewTeacher.Teachercourses.ToList();
            _nameBut = "Сохранить изменения";
        }

        List<Teacherdiscipline>? _teacherdisciplines;
        List<Teachercourse>? _teachercourses;
        public List<Teacherdiscipline>? Teacherdisciplines { get => _teacherdisciplines; set => this.RaiseAndSetIfChanged(ref _teacherdisciplines ,value); }
        public List<Teachercourse>? Teachercourses { get => _teachercourses; set => this.RaiseAndSetIfChanged(ref _teachercourses,value); }

        Discipline? selectedDiscipline;
        public Discipline? SelectedDiscipline
        {
            get => null;
            set
            {
                if (value != null)
                {
                    NewTeacher.Teacherdisciplines.Add(new Teacherdiscipline() { Teacher = NewTeacher, Discipline = value });
                    Teacherdisciplines = NewTeacher.Teacherdisciplines.ToList();
                    this.RaisePropertyChanged(nameof(Disciplines));

                }
            }
        }

        public void DeleteDiscipline(Teacherdiscipline deleteDiscipline)
        {
            NewTeacher.Teacherdisciplines.Remove(deleteDiscipline);
            Teacherdisciplines = NewTeacher.Teacherdisciplines.ToList();
            this.RaisePropertyChanged(nameof(Disciplines));
        }

        Course? selectedCourse;
        public Course? SelectedCourse
        {
            get => null;
            set
            {
                if (value != null)
                {
                    NewTeacher.Teachercourses.Add(new Teachercourse() { Teacher = NewTeacher, Course = value });
                    Teachercourses = NewTeacher.Teachercourses.ToList();
                    this.RaisePropertyChanged(nameof(Courses));

                }
            }
        }

        public void DeleteCourse(Teachercourse deleteCourse)
        {
            NewTeacher.Teachercourses.Remove(deleteCourse);
            Teachercourses = NewTeacher.Teachercourses.ToList();
            this.RaisePropertyChanged(nameof(Courses));
        }

        public void AddCourse()
        {
            MainWindowViewModel.Instance.PageContent = new AddCourseV();
        }


        public void AddChangeTeacher()
        {
            if (NewTeacher.IdTeacher == 0)
            {
                MainWindowViewModel.myConnection.Teachers.Add(NewTeacher);
            }
            MainWindowViewModel.myConnection.SaveChanges();

            MainWindowViewModel.Instance.PageContent = new ShowTeacherV();
        }
    }
}
